﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Threading;
using Rnwood.SmtpServer;
using System.Text.RegularExpressions;
using System.IO;
using Smtp4DevSvc.Properties;

namespace Smtp4DevSvc
{
    public partial class Service1 : ServiceBase
    {
        private Server _server;
        public Service1()
        {
            InitializeComponent();
            eventLog1.Source = "Smtp4DevSvc";
        }

        protected override void OnStart(string[] args)
        {
            eventLog1.WriteEntry("In OnStart, starting Smtp4Dev Server");
            StartServer();
        }

        protected override void OnStop()
        {
            eventLog1.WriteEntry("In OnStop, stopping Smtp4Dev Server");
            StopServer();
        }
        private void StartServer()
        {
            new Thread(ServerWork).Start();
        }
        private void ServerWork()
        {
            try
            {

                ServerBehaviour b = new ServerBehaviour();
                b.MessageReceived += OnMessageReceived;
                b.SessionCompleted += OnSessionCompleted;

                _server = new Server(b);
                _server.Run();
            }
            catch (Exception exception)
            {
                eventLog1.WriteEntry("Exception starting service on port 25. " + exception.Message);
            }
        }
        private void OnSessionCompleted(object sender, SessionEventArgs e)
        {
            //Invoke((MethodInvoker)(() => { _sessions.Add(new SessionViewModel(e.Session)); }));
        }

        private void OnMessageReceived(object sender, MessageEventArgs e)
        {
            eventLog1.WriteEntry("Receiving email message... processing");
            MessageViewModel message = new MessageViewModel(e.Message);
            Directory.CreateDirectory(Settings.Default.DefaultStorePath);
            string regexSearch = new string(Path.GetInvalidFileNameChars()) + new string(Path.GetInvalidPathChars());
            Regex r = new Regex(string.Format("[{0}]", Regex.Escape(regexSearch)));
            string subjectFiltered = r.Replace(message.Subject, "");
            message.SaveToFile(new FileInfo(Settings.Default.DefaultStorePath.TrimEnd('\\') + "\\" + subjectFiltered + " - " + DateTime.Now.ToString("u").Replace(':', '.') + ".eml"));
            eventLog1.WriteEntry("Message received from: " + message.From);
        }

        private void Quit()
        {
            if (_server.IsRunning)
            {
                StopServer();
            }
        }
        private void StopServer()
        {
            if (_server.IsRunning)
            {
                _server.Stop();
            }
        }
    }
}
